Core - Bug # 59587

Epic # 55070 (Accepted): Workpackages

Epic # 55065 (New): WP: Overall System Performance (Backend and Frontend)

Status: Resolved Priority: Must have
Author: Florian Schwaiger Category: Caching
Created: 2014-06-15 Assigned To: Alexander Opitz
Updated: 2014-07-08 Due date:

TYPO3 Version: 6.2

PHP Version: 5.4

Complexity: medium

Is Regression: No

Sprint Focus:

Subject: Performance killer: APC cache backend, wrong assignment of cache tags

Description

It adds way too many tags to the "ident_..." entries due to wrong usage of for loop. This results in ident-to-tag-mappings that are

larger than the actual cache entries themselves.

Check the attached patch which solves the bug.

Please merge the fix soon so we can update our server.

Related issues:
related to Core - Bug # 62513: Backport #59587 to TYPO3 4.5

Resolved

2014-10-28

Associated revisions

Revision 3d930170 - 2014-07-08 22:42 - Alexander Opitz

[BUGFIX] Too many tags by identifier in CacheBackends

This applies to Apc/Memcached/Wincache/Xcache backends.

After an array_merge the values aren't unique. This leads to duplicate

tags per identifier. This patch changes that and also moves the

findTagsByldentifier call out of the foreach loop.

Resolves: #59587

Releases: 6.3, 6.2, 6.1

Change-Id: Id31e16fadbba11038ba692a483fb9a33808d95fa
Reviewed-on: https://review.typo3.0rg/30767

Reviewed-by: Wouter Wolters

Tested-by: Wouter Wolters

Reviewed-by: Markus Klein

Tested-by: Markus Klein

Revision 5a11bbe8 - 2014-07-08 22:57 - Alexander Opitz

[BUGFIX] Too many tags by identifier in CacheBackends

This applies to Apc/Memcached/Wincache/Xcache backends.
https://review.typo3.org/30767

After an array_merge the values aren't unique. This leads to duplicate
tags per identifier. This patch changes that and also moves the
findTagsByldentifier call out of the foreach loop.

Resolves: #59587

Releases: 6.3, 6.2, 6.1

Change-Id: Id31e16fadbba11038ba692a483fb9a33808d95fa
Reviewed-on: https://review.typo3.org/31518

Reviewed-by: Markus Klein
Tested-by: Markus Klein

Revision 072f3555 - 2014-07-08 22:58 - Alexander Opitz

[BUGFIX] Too many tags by identifier in CacheBackends

This applies to Apc/Memcached/Wincache/Xcache backends.

After an array_merge the values aren't unique. This leads to duplicate

tags per identifier. This patch changes that and also moves the

findTagsByldentifier call out of the foreach loop.

Resolves: #59587

Releases: 6.3, 6.2, 6.1

Change-Id: Id31e16fa4bba11038ba692a483fb9a33808d95fa
Reviewed-on: https://review.typo3.0rg/31519

Reviewed-by: Markus Klein

Tested-by: Markus Klein

Revision 3cbad6cd - 2014-07-08 23:03 - Markus Klein

[BUGFIX] Followup to CacheBackend patch

Re-add a missing use statement that vanished during rebase.

Resolves: #59587

Releases: 6.3, 6.2, 6.1

Change-Id: 116ac1b9d5a00c4300202eaef493de43fc988a81d
Reviewed-on: https://review.typo3.org/31520

Reviewed-by: Wouter Wolters

Tested-by: Wouter Wolters

Revision 11fc31e1 - 2014-07-08 23:05 - Markus Klein

[BUGFIX] Followup to CacheBackend patch

Re-add a missing use statement that vanished during rebase.

Resolves: #59587

Releases: 6.3, 6.2, 6.1
Change-Id: [16ac1b9d5a00c4300202eaef493de43fc988a81d
Reviewed-on: https://review.typo3.org/31521

Reviewed-by: Wouter Wolters

Tested-by: Wouter Wolters

Revision 66d2354a - 2014-07-08 23:05 - Markus Klein

[BUGFIX] Followup to CacheBackend patch

Re-add a missing use statement that vanished during rebase.

Resolves: #59587

Releases: 6.3, 6.2, 6.1

Change-Id: 116ac1b9d5a00c4300202eaef493de43fc988a81d
Reviewed-on: https://review.typo3.org/31522

Reviewed-by: Wouter Wolters
Tested-by: Wouter Wolters

History

#1 - 2014-06-17 09:41 - Alexander Opitz

- Status changed from New to Accepted

- Assigned To set to Alexander Opitz

- Complexity changed from no-brainer to easy

By reading the code, this solution seams not correct course the source around also isn't correct, a copy&paste error IMHO.

One line above:

if (array_search($entryldentifier, $existingTags) === FALSE) {

Why do we search the identifier in the existingTags? This should fail every time.

And again one line upper:

$existingTags = $this->findTagsByldentifier($entryldentifier);

Why should we search for all tags in every loop? We know them after first access.

#2 - 2014-06-17 10:05 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30767

#3 - 2014-06-17 10:09 - Alexander Opitz
- Status changed from Under Review to Accepted
- Parent task set to #55065

#4 - 2014-06-17 10:11 - Alexander Opitz

This issue also applies to Memcached/Wincache/Xcache

#5 - 2014-06-17 10:15 - Gerrit Code Review
- Status changed from Accepted to Under Review

Patch set 2 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#6 - 2014-06-17 10:24 - Gerrit Code Review

Patch set 3 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/30767

#7 - 2014-06-18 17:35 - Gerrit Code Review

Patch set 4 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#8 - 2014-06-19 09:53 - Gerrit Code Review

Patch set 5 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#9 - 2014-06-19 12:59 - Gerrit Code Review

Patch set 6 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/30767

#10 - 2014-06-19 13:09 - Gerrit Code Review

Patch set 7 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#11 - 2014-06-19 16:18 - Gerrit Code Review

Patch set 8 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#12 - 2014-06-19 16:49 - Gerrit Code Review
Patch set 9 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.0rg/30767

#13 - 2014-06-19 16:53 - Gerrit Code Review

Patch set 10 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30767

#14 - 2014-06-19 17:28 - Oliver Hader
- Complexity changed from easy to medium

#15 - 2014-07-08 21:46 - Gerrit Code Review

Patch set 11 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/30767

#16 - 2014-07-08 22:31 - Gerrit Code Review

Patch set 12 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/30767

#17 - 2014-07-08 22:43 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.0rg/31518

#18 - 2014-07-08 22:43 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31519

#19 - 2014-07-08 22:56 - Gerrit Code Review

Patch set 2 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31518

#20 - 2014-07-08 23:00 - Gerrit Code Review

Patch set 1 for branch master of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31520

#21 - 2014-07-08 23:04 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-2 of project Packages/TYPO3.CMS has been pushed to the review server.
It is available at https://review.typo3.org/31521
#22 - 2014-07-08 23:04 - Gerrit Code Review

Patch set 1 for branch TYPO3_6-1 of project Packages/TYPO3.CMS has been pushed to the review server.

It is available at https://review.typo3.org/31522

#23 - 2014-07-08 23:30 - Markus Klein
- Status changed from Under Review to Resolved
- % Done changed from 0 to 100

Applied in changeset commit:66d2354a1c505b7e64cc6422f75ce6983f1bcfch.

Files

apc-tags-patch.diff 808 Bytes

2015-08-04

2014-06-15

Florian Schwaiger
